<!-- Note: This file is automatically generated from source code comments. Changes made in this file will be overridden. -->

# Function cosh

Calculate the hyperbolic cosine of a value,
defined as `cosh(x) = 1/2 * (exp(x) + exp(-x))`.

For matrices, the function is evaluated element wise.


## Syntax

```js
math.cosh(x)
```

### Parameters

Parameter | Type | Description
--------- | ---- | -----------
`x` | number &#124; BigNumber &#124; Complex &#124; Unit &#124; Array &#124; Matrix | Function input

### Returns

Type | Description
---- | -----------
number &#124; BigNumber &#124; Complex &#124; Array &#124; Matrix | Hyperbolic cosine of x


## Examples

```js
math.cosh(0.5);       // returns number 1.1276259652063807
```


## See also

[sinh](sinh.md),
[tanh](tanh.md)
