<!-- Note: This file is automatically generated from source code comments. Changes made in this file will be overridden. -->

# Function setDifference

Create the difference of two (multi)sets: every element of set1, that is not the element of set2.
Multi-dimension arrays will be converted to single-dimension arrays before the operation.


## Syntax

```js
math.setDifference(set1, set2)
```

### Parameters

Parameter | Type | Description
--------- | ---- | -----------
`a1` | Array &#124; Matrix | A (multi)set
`a2` | Array &#124; Matrix | A (multi)set

### Returns

Type | Description
---- | -----------
Array &#124; Matrix | The difference of two (multi)sets


## Examples

```js
math.setDifference([1, 2, 3, 4], [3, 4, 5, 6]);            // returns [1, 2]
math.setDifference([[1, 2], [3, 4]], [[3, 4], [5, 6]]);    // returns [1, 2]
```


## See also

[setUnion](setUnion.md),
[setIntersect](setIntersect.md),
[setSymDifference](setSymDifference.md)
