<!-- Note: This file is automatically generated from source code comments. Changes made in this file will be overridden. -->

# Function setIsSubset

Check whether a (multi)set is a subset of another (multi)set. (Every element of set1 is the element of set2.)
Multi-dimension arrays will be converted to single-dimension arrays before the operation.


## Syntax

```js
math.setIsSubset(set1, set2)
```

### Parameters

Parameter | Type | Description
--------- | ---- | -----------
`a1` | Array &#124; Matrix | A (multi)set
`a2` | Array &#124; Matrix | A (multi)set

### Returns

Type | Description
---- | -----------
boolean | true | false


## Examples

```js
math.setIsSubset([1, 2], [3, 4, 5, 6]);        // returns false
math.setIsSubset([3, 4], [3, 4, 5, 6]);        // returns true
```


## See also

[setUnion](setUnion.md),
[setIntersect](setIntersect.md),
[setDifference](setDifference.md)
